{

 fidoaddr.pp - part of unit fidomask (fidomask.pp)
 (c) Andrew V. Sichevoi
 
 License: GNU GPL v2.0 (or high)
 
}

Unit FidoAddr;

 INTERFACE

  Procedure CutFTNDomain(Var Address  : String);
  Function FTNZone (Address : String) : String;
  Function FTNNet  (Address : String) : String;
  Function FTNNode (Address : String) : String;
  Function FTNPoint(Address : String) : String;

 IMPLEMENTATION

Const
     Colon = ':';
     Slash = '/';
     Dot   = '.';
     ALet  = '@';
     Error = 'Error';

Procedure CutFTNDomain(Var Address : String);
Var
   P : Byte;
Begin

 P:=Pos(ALet, Address);
 If P <> 0 Then Address[0]:=Chr(P-1);

End;

Function FTNZone(Address : String) : String;
Var
   _Zone : String;
   I     : Byte;
Begin

 _Zone:='';
 I    :=1;
 If (Pos(Colon, Address)) <> 0 Then
  While Address[I] <> Colon Do Begin
   _Zone:=_Zone + Address[I];
   Inc(I);
  End;
 If (_Zone = '') Then _Zone:=Error;
 FTNZone:=_Zone;

End;

Function FTNNet(Address : String) : String;
Var
   _Net   : String;
   Cp, Sp : Byte; {Colon postion, Slash position}
   I      : Byte;
Begin

 _Net:='';
 Cp  :=Pos(Colon, Address);
 Sp  :=Pos(Slash, Address);
 If (Sp > Cp) Then
  For I:=Cp+1 To Sp-1 Do _Net:=_Net+Address[I];
 If (_Net = '') Then _Net:=Error;
 FTNNet:=_Net;

End;

Function FTNNode(Address : String) : String;
Var
   _Node  : String;
   I      : Byte;
   Sp, Dp : Byte;

Begin

 _Node:='';
 Dp   :=Pos(Dot, Address);
 Sp   :=Pos(Slash, Address);
 If (Dp <> 0) Then Begin
  If (Dp > Sp) Then
   For I:=Sp+1 To Dp-1 Do _Node:=_Node + Address[I];
 End
 Else Begin
  I:=Sp+1;
  While (I <= Length(Address)) Do Begin
   _Node:=_Node + Address[I];
   Inc(I);
  End;
 End;
 If (_Node = '') Then _Node:=Error;
 FTNNode:=_Node;

End;

Function FTNPoint(Address : String) : String;
Var
   _Point : String;
   I      : Byte;
Begin

 _Point:='';
 I     :=Pos(Dot, Address);
 If (I <> 0) Then Begin
  Inc(I);
  While (I <= Length(Address)) Do Begin
   _Point:=_Point+Address[I];
   Inc(I);
  End;
  If (_Point = '') Then _Point:=Error;
  FTNPoint:=_Point;
 End
  Else
  FTNPoint:='0';

End;

End.