//
//
//  ucstr.pp - part of program UUECoder
//  Author : Andrew V. Sichevoi
//           2:6028/9@fidonet
//           sichevoi@mail.ru
//	     www.sichevoi.nm.ru
//
//  License: GNU GPL (v2.0 or high)
//
//

{$IFDEF FPC}
 {$MODE ObjFPC}
{$ENDIF} 

unit UCStr;

 interface
 
//=============================================================================  
const
     CSym  = '#'; {     }
     cErr  = 'ERROR';

   {Convert string to upcase}
  function  UpStr(InStr : String ) : String;
  
   {Convert integer to string}
  function  SStr (InNum : LongInt) : String;
  
   {Convert string to number; need use Round() after this operation}
  function  SVal (InStr : String ) : Real;
  
  function CutWord(Str : String; C1, C2 : Char) : String;
  
  
   {Analog of standart procedure Delete()}
  procedure SDelete(var InStr : String; Index : Byte; Count : Byte);
  
   {Extract from string first word; (c) Vasya Demyanov aka QVasic
    + my add'on: checking for TAB (#9) +  
    }
  procedure Words(str: string; var first_word, last_word: string);
  
  function MacroReplace(InStr : String; _Macro : String; Value : String) : String;
  
//=============================================================================

 implementation
 
//=============================================================================
{=============================================================================}
function UpStr(InStr : String) : String;
var
   Index : Byte;
begin

 for Index:=1 to Length(InStr) do InStr[Index]:=UpCase(InStr[Index]);
 Result:=InStr;
 
end;    
{=============================================================================}
function SStr(InNum : LongInt) : String;
var
   Temp : String;
begin

 Str(InNum, Temp);
 Result:=Temp;
 
end;
{=============================================================================} 
function SVal(InStr : String) : Real;
var
   Temp : Real;
   Code : LongInt;
begin

 Val(InStr, Temp, Code);
 if (Code = 0) then Result:=Temp else Result:=0;
 
end;
{=============================================================================} 
function CutWord(Str : String; C1, C2 : Char) : String;
var
   K, L : String;
begin
 K:=Str;
  SDelete(K, 1, Pos(C1, Str));
  L:=Copy(K, 1, Pos(C2, K)-1);
 Result:=L;
end;
{=============================================================================} 
procedure SDelete(var InStr : String; Index : Byte; Count : Byte);
begin

 InStr:=Copy(InStr, 1, Index - 1) + Copy(InStr, (Index + Count), $FF);
 
end;
{=============================================================================}
Procedure Words(str: string; var first_word, last_word: string);
var   i: byte;
tmp_str: string;
begin
     i:=1;
     tmp_str:='';
     while (str[i]=' ') and (i<=length(str)) do inc(i);
     while (str[i]<>' ') and (i<=length(str)) and (str[i]<>CSym) do
        begin
         if Str[i]<>#9 then
          Begin
           tmp_str:=tmp_str+str[i];
           inc(i);
          End
     end;
     first_word:=tmp_str;
     tmp_str:='';
     while (str[i]=' ') and (i<=length(str)) do inc(i);
     while (i<=length(str)) and (str[i]<>CSym) do
         begin
          if Str[i]<>#9 then
           Begin
            tmp_str:=tmp_str+str[i];
            i:=i+1;
           End
     end;
     while tmp_str[length(tmp_str)]=' ' do tmp_str[0]:=chr(ord(tmp_str[0])-1);
     last_word:=tmp_str;
end;
{=============================================================================}

{=============================================================================}
function MacroReplace(InStr : String; _Macro : String; Value : String) : String;
var
   OutStr : String;
   Ps	  : Byte;
begin   
 
 OutStr:= InStr; 
 Ps:= 1;
 while (Ps <> 0) do begin
  Ps:= Pos(UpStr(_Macro), UpStr(OutStr));
  if (Ps <> 0) then begin
   SDelete(OutStr, Ps, Length(_Macro));
   Insert(Value, OutStr, Ps);
  end;
 end;
 MacroReplace:= OutStr;

end;
{=============================================================================}
//============================================================================= 

end.