//
//
//  ucwmsg.pp - part of program UUECoder
//  Author : Andrew V. Sichevoi
//           2:6028/9@fidonet
//           sichevoi@mail.ru
//	     www.sichevoi.nm.ru
//
//  License: GNU GPL (v2.0 or high)
//
//

unit UCWMSG;

 interface
 
//=============================================================================
const
     mskMHL = '[!] skMHL: ';

  procedure WriteMSG;
//=============================================================================

 implementation  
  
uses
    skMHL    , { skMHL Library, AVS edition }
    skOpen   ,
    skCommon , 
    DynArr   , { :: tStrDynArray            }
    UUELib   , { :: UUEncode, lCutUUE       }
    UCCommon , { :: Error (), GetFileName() }
    UCStr    , { :: CSym                    }
    UCVersion, { :: PID                     }
    UCParam  ; { :: Keywords                }
    
//=============================================================================    
{=[ WriteMSG ]================================================================}
procedure WriteMSG;
var
   HT, FT   : pStrDynArray;
   Body     : pStrDynArray;
   Index    : Word;
   Count    : Word;
   F	    : Text;
   S	    : String;
   Base     : pMessageBase;  
   Sender   : tAddress;
   Receiver : tAddress;
   Parts    : Word;
begin

// Templates [start]
 New(HT, Init);
 New(FT, Init);

 Assign(F, _HeadTPL);
 Reset(F);
 while (not EOF(F)) do begin
  Readln(F, S);
  if ((S[1] = CSym) or (S = CSym)) then continue;
  HT^.Insert(S);
 end;
 Close(F);
 
 Assign(F, _FootTPL);
 Reset(F);
 while (not EOF(F)) do begin
  Readln(F, S);
  if ((S[1] = CSym) or (S = CSym)) then continue;  
  FT^.Insert(S);
 end;
 Close(F);
// Templates [end] 
 
// UUE [start] 
 tlMsg:='  [by ' + ProgramName + Space + ProgramVersion + ']';
 New(Body, Init);

 S:= GetFileName(_FileName);
 
 UUEncode(_Filename, S, Body^);
 Parts:= 1;
 
 if (Body^.Count > _Lines) then lCutUUE(Body^, _Lines, Parts);         
 
// UUE [end]

// MSG [start]
 if (not OpenOrCreateMessageBase(Base, _EchoPath)) then
  Error(mskMHL + 'failed to open message base - ' + ExplainStatus(OpenStatus));
  
 if (_MailType = NetMail ) then Base^.SetBaseType(btNetMail ) else
 if (_MailType = EchoMail) then Base^.SetBaseType(btEchoMail);

 for Index:=1 to Parts do begin 
 
  if (Base^.CreateNewMessage) then begin
   StrToAddress(_FAddr, Sender  );
   StrToAddress(_TAddr, Receiver);
  
   if (_MailType = NetMail ) then 
    Base^.SetFromAndToAddress(Sender, Receiver, True) else
   if (_MailType = EchoMail) then
    Base^.SetFromAddress(Sender, True);   
   
   Base^.SetFrom(_FName);
   Base^.SetTo  (_TName);
   Base^.SetSubject(_Subject);
   
   Base^.PutString(#1 + 'PID: ' + ProgramName + Space + ProgramVersion);
   
   for Count:=1 to HT^.Count do begin
    S:= HT^.At(Count);
    ParseStr(S);
    Base^.PutString(S);
   end;

   if (Parts = 1) then
    for Count:=1 to Body^.Count do Base^.PutString(Body^.At(Count)) else 
   if (Parts > 1) then 
    while ((Body^.At(1) <> tlCut) and ((Body^.Count) > 0)) do begin
     Base^.PutString(Body^.At(1));
     Body^.Delete(1);
    end;
   
   if (Body^.Count <> 0) then Body^.Delete(1); {  tlCut }
   
   for Count:=1 to FT^.Count do begin
    S:= FT^.At(Count);
    ParseStr(S);
    Base^.PutString(S);   
   end;
   
{   Base^.PutString('');}
   if (_TAGLine <> '') then Base^.PutString('... ' + _TAGLine);
   Base^.PutString('--- ' + _TearLine);
   Base^.PutOrigin(Sender, _Origin);
   
   with (Base^) do begin
    SetAttribute(maLocal   , aLocal );
    SetAttribute(maKill    , aKillSnt);
    SetAttribute(maPrivate , aPvt);
    SetAttribute(maHold    , aHold);
    SetAttribute(maCrash   , aCrash);
    SetAttribute(maAttach  , aFileF);
    SetAttribute(maFRQ     , aFreq);
    SetAttribute(maRRQ     , aRRQ);                
    SetAttribute(maARQ     , aARQ);
    SetAttribute(maSent    , aSnt);    
    SetAttribute(maURQ     , aURQ);
    SetAttribute(maTransit , aTransit);    
    SetAttribute(maReceived, false);
   end;
   
   if (not Base^.WriteMessage) then 
    Error(msKMHL + 'can''t write message - ' + ExplainStatus(Base^.GetStatus));     

  end else
  Error(mskMHL + 'Can''t create message - ' + ExplainStatus(Base^.GetStatus));
  { if (Base^.CreateNewMessage) ... }
 
  Base^.CloseMessage;
 end; { for index:=1 to Parts... }
 
 CloseMessageBase(Base);   
// MSG [end]

 Dispose(Body, Done);
 Dispose(HT, Done);
 Dispose(FT, Done);
 
 Writeln;
 Write('Message');
 if (Parts > 1) then Write('''s');
 Writeln(' was succefully generated! :-)');

end; { procedure WriteMSG}
 
{=[ WriteMSG ]================================================================}
//=============================================================================

end.