//
//
//  uuecoder.pp - part of program UUECoder
//  Author : Andrew V. Sichevoi
//           2:6028/9@fidonet
//           sichevoi@mail.ru
//	     www.sichevoi.nm.ru
//
//  License: GNU GPL (v2.0 or high)
//
//

program UUECoder;

uses
    UCCommon ,
    UCParam  ,
    UCVersion,
    UCWMSg   ;
    
//=============================================================================
var
   ParamS : String;

{=[ Writeln ]=================================================================}
procedure Writeln(InStr : String);
begin
 
 System.Writeln(InStr);
 
end; 
{=[ Writeln ]=================================================================}

{=[ ShowHelp ]================================================================}
procedure ShowHelp;
begin
 
{ Writeln('');}
 Writeln('Usage: uuecoder <[keywords]>');
 Writeln(' Where keywords is: ');
 Writeln('  [-c<config>] - config file          ');
 Writeln('  -o<FAddr>    - message from address ');
 Writeln('  -f<FName>    - message from name    ');
 Writeln('  -d<TAddr>    - message to address   ');
 Writeln('  -t<TName>    - message to name      ');
 Writeln('  -s[Subj]     - subject of message   ');
 Writeln('  =T[TAGLine]  - TAGLine              ');
 Writeln('  +T[TearLine] - TearLine             ');
 Writeln('  +O[Origin]   - Origin               ');
 Writeln('  +h<HeadTPL>  - header template      ');
 Writeln('  +f<FootTPL>  - footer template      ');
 Writeln('  -e<T><Echo>  - path to echo, where <T> ');
 Writeln('                 type of message base:   ');
 Writeln('                  F - Opus               ');
 Writeln('                  S - Squish             ');
 Writeln('                  J - Jam                ');
 Writeln('  -m<Type>     - type of mail, can be:   ');
 Writeln('                  E - echomail           ');
 Writeln('                  N - netmail            ');
 Writeln('  -F<filename> - filename                ');
 Writeln('  -l<Num>      - how many lines in msg   ');
 Writeln('  [-a<ATTRIB>] - message attributes:     ');
 Writeln('      L:Loc  , K:KillSNT, P:PVT    , H:HOLD  ');
 Writeln('      C:Crash, F:File   , R:FREQ   , Q:RRQ   ');
 Writeln('      A:ARQ  , S:Sent   , T:Transit          ');
 Writeln('  -v           - version of UUECoder         ');
 Writeln('');
 
 Halt(1);
 
end; 
{=[ ShowHelp ]================================================================} 
//============================================================================

begin

 Writeln(ProgramFullPID);
 if ((ParamStr(1) = '-v') or (ParamStr(1) = '--version')) then
   Error(ProgramInfo);
 
 if (ParamCount = 0) then ShowHelp;

 ParamS:=GetParamStr;
 ParseParamStr(ParamS);
 CheckParams;
 
 WriteMSG;
 
end. 