//
//
//  uuelib.pp - part of program UUECoder
//  Author : Andrew V. Sichevoi
//           2:6028/9@fidonet
//           sichevoi@mail.ru
//	     www.sichevoi.nm.ru
//
//  License: GNU GPL (v2.0 or high)
//
//

unit UUELib;

 interface
 
uses
    DynArr; {:: tStrDynArray } 
 

 
//============================================================================= 
const
     tlCut = '---';
     tlMsg : String = '  uuencoded by UUELib (c) Andrew V. Sichevoi';

  procedure UUEncode(FileName    : String; OutName : String;
                     var OutFile : tStrDynArray); 
		     
  procedure lCutUUE (var OrigUUE : tStrDynArray; 
                     Lines       : Word; var _Parts : Word);
		     
//=============================================================================  

 
 implementation

//============================================================================

(*===========================================================================*)
const
     SP = Byte(' ');

type
    TTriplet = Array[0..2] of Byte;
    TKwartet = Array[0..3] of Byte;
 
{=============================================================================} 
function UpperStr(S : String) : String;
var
    sLen : Byte absolute S;
    I    : Byte;
begin

 for I := 1 to sLEN do S[i] := UpCase(S[i]);
 UpperStr := S;
 
end;
{=============================================================================} 
function SStr(InNum : LongInt) : String;
var
   Temp : String;
begin

 Str(InNum, Temp);
 SStr:=Temp;
 
end;
{=============================================================================} 
procedure Triplet2Kwartet(Triplet: TTriplet; var Kwartet: TKwartet);
var
   i : Integer;
begin
 Kwartet[0] := (Triplet[0] SHR 2);
 Kwartet[1] := ((Triplet[0] SHL 4) AND $30) +
               ((Triplet[1] SHR 4) AND $0F);
 Kwartet[2] := ((Triplet[1] SHL 2) AND $3C) +
               ((Triplet[2] SHR 6) AND $03);
 Kwartet[3] := (Triplet[2] AND $3F);
 
 for i:=0 to 3 do
 begin
  if Kwartet[i] = 0 then Kwartet[i] := $40;
  inc(Kwartet[i],SP)
 end;
end; {Triplet2Kwartet}
{=============================================================================} 
{
 This procedure based on program UUENCODE (c) Vitaly Siman 
					   <VIT@fmain.telecom.chel.su>
}
procedure UUEncode(FileName    : String; OutName : String;
		   var OutFile : tStrDynArray); 
var
   F        : File;
   S        : String;
   Triplets : Array[1..15] of TTriplet;
   Kwar     : TKwartet;
   I, J     : Integer;
   CurSize  : Integer;
   
begin

 Assign(F, FileName);
 FileMode:=$40;
 Reset(F, 1);
 
 FillChar(Triplets, SizeOf(Triplets), #0);
 CurSize:=0;

 OutFile.Insert('section 1 of 1 of file ' + OutName + ' ' + tlMSG);
 OutFile.Insert('begin 644 '+ OutName); 

 repeat
  S:='';
  BlockRead(F, Triplets, SizeOf(Triplets), I);
  Inc(CurSize, I);
  S:=S + Char(SP+I);
  for J:=1 to ((I+2) div 3) do begin
   Triplet2Kwartet(Triplets[J], Kwar);
   S:=S + Char(Kwar[0]) + Char(Kwar[1]) + Char(Kwar[2]) + Char(Kwar[3]);
  end;
  OutFile.Insert(S);
 until (I < SizeOf(Triplets));
 
 OutFile.Insert('`');
 OutFile.Insert('end');
 
 Close(F);

end;
{=============================================================================} 
(*===========================================================================*)

{=[ lCutUUE ]=================================================================}
procedure lCutUUE(var OrigUUE : tStrDynArray; Lines : Word; var _Parts : Word);
var
   FLine  : String;
   Index  : Word;
   Line   : Word;
   Flag   : Boolean;
   Parts  : Word;		  
   NewUUE : pStrDynArray;
   
function GetFileName(InStr : String) : String;
var
   Index  : Byte;
   OutStr : String;
   Ps     : Byte;
begin

 GetFileName:= '';
 Ps:= Pos('644 ', InStr);
 if ( Ps <> 0) then begin
  OutStr:= '';
  for Index:= (Ps + 4) to Length(InStr) do OutStr:= OutStr + InStr[Index];
  GetFileName:= OutStr;
 end;

end; 
   
begin

 New(NewUUE, Init);

 Flag:= false;
 OrigUUE.Delete(1);
 FLine:=OrigUUE.At(1); {  }
 
 OrigUUE.Delete(1);      {     }
 OrigUUE.Delete(OrigUUE.Count);
 OrigUUE.Delete(OrigUUE.Count);
 
 Parts :=(OrigUUE.Count) div Lines; {,   }
 if (Parts = 0) then Parts:=1 else begin
  if (OrigUUE.Count mod Lines) <> 0 then Flag:= true;
 end;
 
 if (not Flag) then _Parts:=Parts else _Parts:= Parts + 1;

 for Index:=1 to Parts do begin
  Line:=0;
  NewUUE^.Insert('Section ' + SStr(Index) + ' of ' + SStr(_Parts) +
	         ' of file ' + GetFileName(FLine) + tlMSG);
  NewUUE^.Insert(' ');
  if (Index = 1) then NewUUE^.Insert(FLine);
  
  while (Line <> Lines) do begin
   NewUUE^.Insert(OrigUUE.At(1));
   if (OrigUUE.Count <> 0) then OrigUUE.Delete(1);
   Inc(Line);
  end;
  NewUUE^.Insert('`');
  NewUUE^.Insert('end');
  NewUUE^.Insert(tlCut);
 end;

 if (Flag) then begin
  NewUUE^.Insert('Section ' + SStr(Index + 1) + ' of ' + SStr(_Parts) +
                ' of file ' + GetFileName(FLine) + tlMSG); 
  {NewUUE^.Insert(FLine);}
  NewUUE^.Insert(' ');
  {for Index:=1 to (OrigUUE.Count) do NewUUE^.Insert(OrigUUE.At(Index));}
  while (OrigUUE.Count <> 0) do begin
   NewUUE^.Insert(OrigUUE.At(1));
   OrigUUE.Delete(1);
  end;
  
  NewUUE^.Insert('`');
  NewUUE^.Insert('end');
 end;
 

 for Index:=1 to NewUUE^.Count do begin
  FLine:= NewUUE^.At(Index);
  if (Length(FLine) <> 0) then OrigUUE.Insert(FLine);
 end;
 
 Dispose(NewUUE, Done);
   
end;
{=[ lCutUUE ]=================================================================} 

  


end.